{===========================================================================}
{==                                                                       ==}
{==                       SUPER CORECTOR Version 6.3                      ==}
{==                  Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16384,262144,655355} {16K Stack, 256K HeapMin, 640K HeapMax}

USES Dos,
     GUtils, GMemory, GList, GDialogs, GStdDlgs;

CONST
  Version         = 'Version 6.3';
  CrackTerminator = #28;
  EncryptKey      = 234234234;


TYPE
  PArray = ^TArray;
  TArray = ARRAY[1..65000] OF Byte;

  TFileID = RECORD
           ID  : Word;
    LastUpdate : STRING[20];
          _EOF : Byte;
    TotalGames : Word;
   TotalCracks : Word;
   IndexOffset : Word;
     IndexSize : Word;
    DataOffset : Word;
      DataSize : Word;
  END;

  PFindReplaceCollection = ^TFindReplaceCollection;
  TFindReplaceCollection = OBJECT(TCollection) END;

  PFindReplace = ^TFindReplace;
  TFindReplace = OBJECT(TObject)
    Find       : PString;
    Replace    : PString;
    CONSTRUCTOR Init(NEW_Find,NEW_Replace:STRING);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PCrackCollection = ^TCrackCollection;
  TCrackCollection = OBJECT(TCollection) END;

  PCrack = ^TCrack;
  TCrack = OBJECT(TObject)
    C_Name  : PString;
    F_Name  : PString;
    FR_Data : PFindReplaceCollection;
    CONSTRUCTOR Init(NEW_C_Name, NEW_F_Name: STRING;
                     NEW_FindReplace       : PFindReplaceCollection);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGamesCollection = ^TGamesCollection;
  TGamesCollection = OBJECT(TCollection) END;

  PGame = ^TGame;
  TGame = OBJECT(TObject)
    Name : PString;
    Data : PCrackCollection;
    CONSTRUCTOR Init(NEW_Name:STRING; NEW_Data:PCrackCollection);
    DESTRUCTOR Done; VIRTUAL;
  END;

  { ----------------------------- LIST OBJECTS ---------------------------- }
  PGamesList = ^TGamesList;
  TGamesList = OBJECT(TList)
    FUNCTION  __GetLine     (ListPos:Integer): STRING;              VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer);                      VIRTUAL;
  END;

  PCracksList = ^TCracksList;
  TCracksList = OBJECT(TList)
    FUNCTION  __GetLine     (ListPos:Integer): STRING;              VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer);                      VIRTUAL;
  END;
  { ----------------------------------------------------------------------- }

VAR
  FileID       : TFileID;
  FileName     : STRING;
  Database     : PGamesCollection;
  CurrentGame  : PGame;

  GamesList    : PGamesList;
  CracksList   : PCracksList;

{$I GSUPER63\SC_LOGO.PAS}

FUNCTION Encrypt(St:STRING; Key:LongInt):STRING;
VAR I:Byte;
BEGIN
  RandSeed := Key;
  Encrypt[0] := St[0];
  FOR I := 1 TO Length(St) DO
    Encrypt[I] := Chr(Ord(St[I]) XOR (Random($80) OR $80));
END;

PROCEDURE FatalError(ErrMsg: STRING);
BEGIN
  ClearLine(24,$7);
  Writeln;
  Writeln('FATAL ERROR: ',ErrMsg);
  Cursor(On);
  SetBlink(True);
  Halt(1);
END;

PROCEDURE About;
VAR OK: PButtons; UpY: Byte;
BEGIN
  UpY := MaxY DIV 2-8;
  OpenWin(11,UpY,60,18,$5D,$5F,Single1,'About');
  WriteBetween(10,70,UpY+2,$5E,' SUPER CORECTOR '+Version+' ');
  WriteBetween(10,70,UpY+3,$5E,' Copyright (C) 1994-96 By The GodFather ');
  WriteBetween(10,70,UpY+5,$4F,' THIS PROGRAM IS FREEWARE!');
  WriteBetween(10,70,UpY+7,$57,' If you have any suggestions, bug reports or ');
  WriteBetween(10,70,UpY+8,$57,' information about this program please write me ');
  WriteBetween(10,70,UpY+10,$57,' Contact me here: ');
  WriteBetween(10,70,UpY+12,$5B,' EMAIL: gf@top.bg ');
  WriteBetween(10,70,UpY+13,$5B,' EMAIL: gf@cybcom.net ');
  WriteBetween(10,70,UpY+14,$5B,' URL: http://georgi.top.bg/ ');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,UpY+16,btDefault);
  OK^.Process;
  Dispose(OK, Done);
  RmWin;
END;

PROCEDURE Success;
VAR OK: PButtons; Y: Byte;
BEGIN
  Y := MaxY DIV 2;
  OpenWin(18,Y-5,44,10,$5D,$5F,Special2,'Success');
  WriteBetween(20,60,Y-3,$5B,'Everything went OK !!!');
  WriteBetween(20,60,Y-1,$5E,'The game is CORECTED, so now you');
  WriteBetween(20,60,Y  ,$5E,'can start the game and enjoy !!!');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,Y+3,btDefault);
  OK^.Process;
  Dispose(OK, Done);
  RmWin;
END;

PROCEDURE Fail;
VAR OK: PButtons; Y: Byte;
BEGIN
  Y := MaxY DIV 2;
  OpenWin(14,Y-5,51,11,$4C,$4F,Special2,'Fail');
  WriteBetween(15,65,Y-3,$4F,'Sorry man.');
  WriteBetween(15,65,Y-1,$4E,'I could not find the byte pattern. May be');
  WriteBetween(15,65,Y  ,$4E,'the file is compressed. Try to uncompress it');
  WriteBetween(16,65,Y+1,$4E,'with UP.EXE and then try again with GSUPER.');
  InitPallette(WarningDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,Y+4,btDefault);
  OK^.Process;
  Dispose(OK, Done);
  RmWin;
END;

FUNCTION GetFileName(VAR AName: STRING): Boolean;
VAR FDlg: PDialog; VAR FName: STRING[12];
BEGIN
  FName       := AName;
  GetFileName := False;
  New(FDlg, Init(16,MaxY DIV 2-4,50,8,DefaultDialogPAL,Single1,'Change file name'));
  WITH FDlg^ DO
  BEGIN
    AddTxtInputLine(12,3,'~F~ile',kbAltF,17,3,12,ilFileName,FName);
    AddButtons;
     AddButton('    ~O~K    ',kbAltO,11,6,btDefault);
     AddButton('  ~C~ancel  ',kbAltC,30,6,btCancel);
    IF (Process(1) = 1)
      THEN BEGIN
             AName := FName;
             GetFileName := True;
           END;
  END;
  Dispose(FDlg, Done);
END;

FUNCTION ReplaceShortenings(ST: STRING): STRING;
VAR TmpST,S1,S2: STRING;
BEGIN
  TmpST := Copy(ST, Pos(' ',ST), (Length(ST)-Pos(' ',ST))+1 );
  S1 := St[1]; S2 := St[2];
  CASE S1[1] OF
    '!': S1 := 'Make';
    '@': S1 := 'Remove';
    '#': S1 := 'Stop';
    '$': S1 := 'Unlimited';
  END;
  CASE S2[1] OF
    '!': S2 := ' BALLS';
    '@': S2 := ' BOMBS';
    '#': S2 := ' BULLETS';
    '$': S2 := ' ENERGY';
    '%': S2 := ' LIFE';
    '^': S2 := ' LIFES';
    '&': S2 := ' MONEY';
    '*': S2 := ' MISSLES';
    '(': S2 := ' PASSWORDS';
    ')': S2 := ' SHIELD';
    '_': S2 := ' TIME';
    '+': S2 := ' TIMER';
   ELSE IF S2 = ' ' THEN S2 := '';
  END;
  TmpST := ' '+S1+S2+TmpST;
  IF TmpST[3] = ' ' THEN Delete(TmpST,1,3);
  ReplaceShortenings := TmpST;
END;


PROCEDURE WriteINFOFile;
VAR
  INFOFile: Text;
  AGame   : PGame;
  ACrack  : PCrack;
  Buffer  : Pointer;
  TMPStr  : STRING;
  I,R     : Word;

  PROCEDURE SetSTR(Ch1,Ch2,Ch3,Ch4:Char);
  BEGIN
    TMPStr := Replicate(94,Ch1);
    TMPStr[1 ] := Ch2;
    TMPStr[43] := Ch3;
    TMPStr[79] := Ch3;
    TMPStr[94] := Ch4;
  END;

BEGIN
  IF NOT PromptBox('Write INFO File?',False) THEN Exit;
  Assign(INFOFile,'GSUPER.INF');
  {$I-}
    Rewrite(INFOFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error creating GSUPER.INF',True);
    Exit;
  END;
  GetMem(Buffer,64000);
  SetTextBuf(INFOFile,Buffer^,64000);
  Writeln(INFOFile);
  Writeln(INFOFile,PadCenter('Full catalog of cracks in SUPER CORECTOR '+Version,80,' '));
  Writeln(INFOFile,#13#10);
  Writeln(INFOFile,PadCenter('TOTALS',80,' '));
  Writeln(INFOFile);
  Writeln(INFOFile,Replicate(31,' '),AddComas(Database^.Count)+' cracked games');
  Writeln(INFOFile,Replicate(31,' '),AddComas(FileID.TotalCracks)+' cracks');
  Writeln(INFOFile);
  SetSTR('','','',''); Writeln(INFOFile,TMPStr);
  SetSTR(' ','','','');
  OverWrite(16,TMPStr,'GAME NAME');
  OverWrite(54,TMPStr,'WHAT IS CORECTED');
  OverWrite(83,TMPStr,'FILENAME');
  Writeln(INFOFile,TMPStr);
  SetSTR('','','',''); Writeln(INFOFile,TMPStr);
  {$I-}
  FOR I := 0 TO Database^.Count-1 DO
  BEGIN
    AGame := Database^.At(I);
    Write(INFOFile,' ',PadLeft(AGame^.Name^,40,' '));
    FOR R := 0 TO AGame^.Data^.Count - 1 DO
    BEGIN
      IF R <> 0 THEN Write(INFOFile,' ',Replicate(40,' '));
      ACrack := AGame^.Data^.At(R);
      TMPStr := ReplaceShortenings(ACrack^.C_Name^);
      Write  (INFOFile,'',PadLeft(TMPStr,35,' '));
      Writeln(INFOFile,' ',PadLeft(ACrack^.F_Name^,12,' '),' ');
    END;
    IF I = Database^.Count-1
      THEN SetSTR('','','','')
      ELSE SetSTR('','','','');
    Writeln(INFOFile,TMPStr);
  END;
  Close(INFOFile);
  FreeMem(Buffer,64000);
  {$I+}
  InfoBox('GSUPER.INF saved OK!',False);
END;

{---------------------------------------------------------------------------}
{---------------------------- OBJECT PROCEDURES ----------------------------}
{---------------------------------------------------------------------------}
CONSTRUCTOR TFindReplace.Init(NEW_Find,NEW_Replace:STRING);
BEGIN
  Find    := NewStr(NEW_Find);
  Replace := NewStr(NEW_Replace);
END;

DESTRUCTOR TFindReplace.Done;
BEGIN
  DisposeStr(Find);
  DisposeStr(Replace);
END;

{---------------------------------------------------------------------------}
CONSTRUCTOR TCrack.Init(NEW_C_Name,NEW_F_Name:STRING;
                        NEW_FindReplace      :PFindReplaceCollection);
BEGIN
  C_Name  := NewStr(NEW_C_Name);
  F_Name  := NewStr(NEW_F_Name);
  FR_Data := NEW_FindReplace;
END;

DESTRUCTOR TCrack.Done;
BEGIN
  DisposeStr(C_Name);
  DisposeStr(F_Name);
  Dispose(FR_Data,Done);
END;


{---------------------------------------------------------------------------}
CONSTRUCTOR TGame.Init(NEW_Name:STRING; NEW_Data:PCrackCollection);
BEGIN
  Name := NewStr(NEW_Name);
  Data := NEW_Data;
END;

DESTRUCTOR TGame.Done;
BEGIN
  DisposeStr(Name);
  Dispose(Data,Done);
END;



{---------------------------------------------------------------------------}
{--------------------------- CHECK FILE HEADER -----------------------------}
{---------------------------------------------------------------------------}
FUNCTION CheckFileHeader(FName:STRING): Boolean;
VAR DataFile:FILE;
BEGIN
  Assign(DataFile,FName);
  {$I-}
    Reset(DataFile,1);
    BlockRead(DataFile,FileID,SizeOf(FileID));
    Close(DataFile);
  {$I+}
  FileID.LastUpdate[0] := #20;
  CheckFileHeader := (FileID.ID = $6353);
END;


{---------------------------------------------------------------------------}
{------------------------------- LOAD DATABASE -----------------------------}
{---------------------------------------------------------------------------}
VAR
  StringData,IndexData : PArray;
  CurrentPos           : Word;
  CurrentLine          : Word;
  AllLinesProceded     : Boolean;


 PROCEDURE ReadString(VAR OutStr:STRING);
 VAR CurrentLength:Byte;
 BEGIN
  IF Succ(CurrentLine) = FileID.IndexSize
    THEN AllLinesProceded := True;
  Inc(CurrentLine);
  CurrentLength := IndexData^[CurrentLine];
  MoveMem(StringData^[CurrentPos],OutStr[1],CurrentLength);
  OutStr[0] := Chr(CurrentLength);
  Inc(CurrentPos, CurrentLength);
  OutStr := Encrypt(OutStr,EncryptKey);
 END;

 PROCEDURE ReadDatafile(FName:STRING);
 VAR DataFile:FILE; Ndx:Word;
 BEGIN
  CurrentPos       := 1;
  CurrentLine      := 0;
  AllLinesProceded := False;
  New(StringData); New(IndexData);
  Assign(DataFile,FName);
  {$I-}
      Reset(DataFile,1);
      Seek(DataFile,FileID.IndexOffset);
      BlockRead(DataFile,IndexData^,FileID.IndexSize);

      FOR Ndx := 1 TO FileID.IndexSize DO
        IndexData^[Ndx] := IndexData^[Ndx] XOR $A6;

      Seek(DataFile,FileID.DataOffset);
      BlockRead(DataFile,StringData^,FileID.DataSize);
      Close(DataFile);
  {$I+}
 END;


PROCEDURE LoadCrackData;
VAR
  _GName: STRING;
  C_Data: PCrackCollection;

  PROCEDURE GetCrk; NEAR;
  VAR TmpDTA: PCrackCollection;
      Tmp_FR: PFindReplaceCollection;
      FR_Dta: PFindReplaceCollection;
      _CName,
      _FName,
      _Find,
      _Replace: STRING;

     PROCEDURE INIT_FindReplace_DATA;
     VAR FR_DTA:PFindReplaceCollection; OneTime:Boolean; LengthFind:Byte;
     BEGIN
       New(FR_DTA,Init(1,1));
       REPEAT
         OneTime := True;
         ReadString(_Find);
         ReadString(_Replace);

         LengthFind := Length(_Find);
         IF _Find[LengthFind] = Chr($2B) THEN
           IF _Find[LengthFind-1] = Chr($2B) THEN
           BEGIN
             OneTime     := False;
             System.Delete(_Find   ,LengthFind-1,2);
             System.Delete(_Replace,LengthFind-1,2);
           END;

         FR_DTA^.Insert(New(PFindReplace, Init(_Find,_Replace)));
       UNTIL OneTime;
       Tmp_FR := FR_DTA;
     END;

  BEGIN
    New(TmpDTA,Init(1,1));
    REPEAT
      ReadString(_CName); IF _CName = CrackTerminator THEN Break;
      ReadString(_FName);
      Init_FindReplace_Data;
      TmpDTA^.Insert(New(PCrack, Init(_CName,_FName,Tmp_FR)));
    UNTIL AllLinesProceded;
    C_Data := TmpDTA;
  END;

VAR Max,Current:Word; UpY:Byte;
BEGIN
  FileName := 'GSUPER.DAT';
  IF NOT FindFile(FileName)
    THEN FatalError('Can''t find GSUPER.DAT');
  IF CheckFileHeader(FileName)
    THEN ReadDataFile(FileName)
    ELSE FatalError(FileName+' is not a SUPER CORECTOR`s Datafile');

  Max     := FileID.TotalGames;
  Current := 0;
  UpY     := MaxY DIV 2 + 9;
  FBox(16,UpY,69,UpY+2,$19,Special2);
  WriteHi(34,upY,$19,$1E,'[ ~Loading data~ ]');
  FastWrite(17,UpY+1,$1B,Replicate(50,' '));

  Database:= New(PGamesCollection, Init(1, 1));
  REPEAT
    ReadString(_GName);
    GetCrk;

    PlainWrite(41,UpY+1,IntToStr(RetPercent(100,Max,Current))+'%');
    Attribute (18,UpY+1,$F0,(RetPercent(50,Max,Current)));
    Inc(Current);

    Database^.Insert(New(PGame, Init(_GName,C_Data)));
  UNTIL AllLinesProceded;
  Dispose(IndexData);
  Dispose(StringData);
END;
{---------------------------------------------------------------------------}
{------------------------------- READ DATABASE -----------------------------}
{---------------------------------------------------------------------------}


{ ------------------------------------------------------------------------- }
{ ----------------------------- CRACK THE GAME ---------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE CrackTheGame;
LABEL Quit;
CONST ARRAYSize = 64000;
TYPE TArray = ARRAY[1..ARRAYSize] OF Byte;
VAR
  TheGame     : PGame;
  TheCrack    : PCrack;
  FndRepColl  : PFindReplaceCollection;
  FindReplace : PFindReplace;

  SearchFor,
  ReplaceWith : STRING;

  SourceFile  : STRING;

  Index,
  R,T,
  Index2,
  Readen,
  Founded     : Word;
  Max,Current,
  Counts      : LongInt;
  Source      : FILE;
  Dest        : FILE OF Byte;

  FBuffer     : ^TArray;
  Error       : Byte;

  PROCEDURE DisplayTermometer;
  BEGIN
    PlainWrite(41,MaxY DIV 2,IntToStr(RetPercent(100,Max,Current))+'%');
    Attribute (18,MaxY DIV 2,$F0,(RetPercent(50,Max,Current)));
  END;

  PROCEDURE MakeChanges;
  VAR Offset: LongInt;
  BEGIN
    Inc(Founded);
    Offset := LongInt(Counts*ArraySize) + Index2;
    {$I-}
      Seek(Dest,Offset);
      FOR Offset := 1 TO Length(ReplaceWith)
        DO Write(Dest,Byte(ReplaceWith[Offset]));
    {$I+}
    IF IOResult <> 0 THEN Error := 3;
  END;

BEGIN
  Error       := 0;
  Founded     := 0;
  TheGame     := Database^.At(GamesList^.LSTPosition-1);
  TheCrack    := TheGame^.Data^.At(CracksList^.LSTPosition-1);
  FndRepColl  := TheCrack^.FR_DATA;
  SourceFile  := TheCrack^.F_Name^;

  Assign(Source,SourceFile);
  Assign(Dest  ,SourceFile);
  {$I-}
    Reset(Source,1);
    Reset(Dest);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error opening '+SourceFile,True);
    Exit;
  END;
  Counts := 0;
  GetMem(FBuffer,SizeOf(FBuffer^));

  Current := 0;
  Max     := FileSize(Source) * FndRepColl^.Count;

  MkWin(13,MaxY DIV 2-4,59,6,$5D,Single1,'');
  WriteBetween(14,72,MaxY DIV 2-2,$5E,'Searching & Replacing bytes in '+SourceFile);

  FastWrite(18,MaxY DIV 2  ,$0F,Replicate(50,' '));
  PlainWrite(41,MaxY DIV 2,AddComas(RetPercent(100,Max,Current))+'%');

  FOR Index := 0 TO FndRepColl^.Count-1 DO
  BEGIN
    Counts      := 0;
    FindReplace := FndRepColl^.At(Index);
    SearchFor   := FindReplace^.Find^;
    ReplaceWith := FindReplace^.Replace^;
    Insert(' ',SearchFor,1);
    Seek(Source,0);
    REPEAT
      {$I-}
        BlockRead(Source,FBuffer^,SizeOf(FBuffer^),Readen);
      {$I+}
      IF IOResult <> 0 THEN BEGIN Error := 2; GOTO Quit; END;

      Inc(Current,Readen);
      FOR Index2 := 0 TO Readen DO
      BEGIN
        R:=1; T:=1;
        WHILE FBuffer^[Index2+R] = Ord(SearchFor[R+1]) DO
        BEGIN
          Inc(R);
          Inc(T);
        END;
        IF T = Length(SearchFor) THEN MakeChanges;
        IF Error <> 0 THEN GOTO Quit;
      END;
      DisplayTermometer;
      Inc(Counts);
    UNTIL Readen = 0;
  END;
Quit:
  FreeMem(FBuffer, SizeOf(FBuffer^));
  {$I-}
    Close(Source);
    Close(Dest);
  {$I+}
  RmWin;
  CASE Error OF
    2: InfoBox('Error reading '+SourceFile,True);
    3: InfoBox('Error writing in '+SourceFile,True);
  END;
  IF (Founded<>0) AND (Error=0) THEN Success ELSE Fail;
END; {CrackTheGame}



{ ------------------------------------------------------------------------- }
{ -------------------------- TCrackList ROUTINES -------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE TCracksList.__HookListKeys(ListPos: Integer; VAR PressedKey:Word);
VAR TheCrack: PCrack;

  FUNCTION ChangeName: Boolean;
  VAR Name: STRING;
  BEGIN
    ChangeName := False;
    TheCrack   := CurrentGame^.Data^.At(ListPos-1);
    Name       := TheCrack^.F_Name^;
    IF Name = '?' THEN Name := '';
    IF (GetFileName(Name)) THEN
    BEGIN
      DisposeStr(TheCrack^.F_Name);
      IF Name = '' THEN Name := '?';
      TheCrack^.F_Name := NewStr(Name);
      ChangeName := True;
      IF Name = '?' THEN ChangeName := False;
    END;
  END;

  PROCEDURE Corect;
  VAR FName: STRING;
  BEGIN
    TheCrack := CurrentGame^.Data^.At(LSTPosition-1);
    FName    := TheCrack^.F_Name^;
    IF FName <> '?'
      THEN CrackTheGame
      ELSE IF ChangeName
             THEN CrackTheGame;
  END;

BEGIN
  CASE PressedKey OF
        kbF1: About;
       kbF10: WriteINFOFile;
     kbEnter: Corect;
     kbSpace: ChangeName;
      kbTab,
      kbsTab,
      kbLeft: EndOfList := True;
  END;
END;

FUNCTION TCracksList.__GetLine(ListPos: Integer): STRING;
VAR TheCrack: PCrack;
BEGIN
  TheCrack  := CurrentGame^.Data^.At(ListPos-1);
  __GetLine := ReplaceShortenings(TheCrack^.C_Name^);
END;

PROCEDURE TCracksList.__IdleListCall(ListPos: Integer);
VAR
  AnEntry : PGame;
  TheCrack: PCrack;
BEGIN
  AnEntry  := CurrentGame;
  TheCrack := AnEntry^.Data^.At(ListPos-1);
  FastWrite(63,MaxY-6,$1A,TheCrack^.F_Name^+Replicate(12-Length(TheCrack^.F_Name^),' '));
END;

PROCEDURE InitTCracksList;
BEGIN
  CurrentGame := DataBase^.At(GamesList^.LSTPosition-1);
  CracksList := New(PCracksList,
                         Init(42,              { ListX       : Byte;    }
                              7,               { ListY       : Byte;    }
                              38,              { BarSize     : Byte;    }
                              MaxY-14,         { Lines       : Byte;    }
                              CurrentGame^.Data^.Count, { MaxTopics   : Integer; }
                              False,           { SelectionON : Boolean; }
                              False,           { FastFindON  : Boolean; }
                              0,               { FastFindX   : Byte;    }
                              0,               { FastFindY   : Byte;    }
                              #0,              { FastFindCHR : Char;    }
                              True,            { ScrollerON  : Boolean; }
                              80,              { ScrollerX   : Byte;    }
                              7,               { ScrollerY1  : Byte;    }
                              MaxY-8,          { ScrollerY2  : Byte;    }
                              lDefaultPal));   { Pallette    : Pals;    }
  CracksList^.Process;
  Dispose(CracksList,Done);
  WriteVScrollBar(80,7,MaxY-8,$19,1,2);
END;


{ -------------------------------------------------------------------------- }
{ ----------------------------- TGamesList ROUTINES ------------------------ }
{ -------------------------------------------------------------------------- }
FUNCTION TGamesList.__GetLine(ListPos: Integer): STRING;
BEGIN
  CurrentGame := Database^.At(ListPos-1);
  __GetLine   := ' '+CurrentGame^.Name^;
END;

PROCEDURE TGamesList.__IdleListCall(ListPos: Integer);
VAR
  AnEntry : PGame;
  TheCrack: PCrack;
  NameSTR : PString;
  DataSTR : PString;
  TempSTR : STRING;
  I,R     : Word;
BEGIN
  AnEntry := Database^.At(ListPos-1);
  NameSTR := AnEntry^.Name;
  FastWrite(42,4,$1E,PadCenter(NameSTR^,38,' '));
  R := 7;
  FOR I := 1 TO MaxY-14 DO
  BEGIN
    TheCrack := AnEntry^.Data^.At(I-1);
    TempSTR := ReplaceShortenings(TheCrack^.C_Name^);
    FastWrite(42,R,$17,TempSTR+Replicate(38-Length(TempStr),' '));
    Inc(R);
    IF I = AnEntry^.Data^.Count THEN Break;
  END;
  ClearText(42,R,79,MaxY-8,$10);
  TheCrack := AnEntry^.Data^.At(0);
  FastWrite(63,MaxY-6,$1A,TheCrack^.F_Name^+Replicate(12-Length(TheCrack^.F_Name^),' '));
END;

PROCEDURE TGamesList.__HookListKeys(ListPos: Integer; VAR PressedKey:Word);
BEGIN
  CASE PressedKey OF
    kbF1: About;

kbCtrlF2: Success;
kbCtrlF3: Fail;

   kbF10: WriteINFOFile;

   kbTab,
  kbsTab,
 kbRight,
 kbEnter: BEGIN
               Attribute(2,ListY+Pred(CurrentY),$1F,39);
               InitTCracksList;
               Attribute(2,ListY+Pred(CurrentY),Pallette[lBar],39);
             END;
  END;
END;
{ -------------------------------------------------------------------------- }
{ -------------------------------------------------------------------------- }


PROCEDURE Initialize;
BEGIN
  Cursor(Off);
  SetBlink(False);
  MaxKeyboardSpeed;

  ClrScr(7);
  PartRestore(1,(MaxY DIV 2)-11,80,(MaxY DIV 2)+13,_SCorectorLOGO);
  PosCursor(1,MaxY-4);

  LoadCrackData;
  ClrScr(7);
  SetPal(AltPAL);
  ClearLine(24,$07);
  FastWrite(1,1, $0A, PadCenter('SUPER CORECTOR '+Version,80,' '));
  FastWrite(1,MaxY,$0A, PadCenter('Copyright (C) 1994-97 by The GodFather',80,' '));
  FBox(1,2,80, MaxY-1,$19,Double1);
  WriteBetween(1 ,39,2,$1B,' Corected games ');
  WriteBetween(41,80,2,$1B,' What is corected ');
  SmartVLine(41, 2,MaxY-1,$19,SingleLine);
  SmartHLine(41,80,     6,$19,SingleLine);
  SmartHLine(41,80,MaxY-7,$19,SingleLine);
  SmartHLine(41,80,MaxY-5,$19,SingleLine);
  FastWrite(43,MaxY-6,$1E,'Game is corected in');
  FastWrite(43,MaxY-4,$1E,'Total games     '+AddComas(Database^.Count));
  FastWrite(43,MaxY-3,$1E,'Total cracks    '+AddComas(FileID.TotalCracks));
  FastWrite(43,MaxY-2,$1E,'Datafile date   '+FileID.LastUpdate);
  SmartVLine(57,MaxY-5,MaxY-1,$19,SingleLine);
  ClearAttr(58,MaxY-4,79,MaxY-2,$1A);
  WriteVScrollBar(80,7,MaxY-8,$19,1,2);
  PosCursor(MaxX,MaxY);
  ClearAttr(MaxX,MaxY,MaxX,MaxY,$00);
  GamesList := New(PGamesList,
                         Init(2,               { ListX       : Byte;    }
                              3,               { ListY       : Byte;    }
                              39,              { BarSize     : Byte;    }
                              MaxY-4,          { Lines       : Byte;    }
                              Database^.Count, { MaxTopics   : Integer; }
                              False,           { SelectionON : Boolean; }
                              True,            { FastFindON  : Boolean; }
                              5,               { FastFindX   : Byte;    }
                              MaxY-1,          { FastFindY   : Byte;    }
                              '',             { FastFindCHR : Char;    }
                              True,            { ScrollerON  : Boolean; }
                              41,              { ScrollerX   : Byte;    }
                              3,               { ScrollerY1  : Byte;    }
                              MaxY-2,          { ScrollerY2  : Byte;    }
                              lDefaultPal));   { Pallette    : Pals;    }
  GamesList^.Process;
END;

PROCEDURE ExitPGM;
BEGIN
  Dispose(GamesList, Done);
  Dispose(Database, Done);
  ClrScr(7);
  SetPal(OrgPAL);
  PartRestore(1,(MaxY DIV 2)-11,80,(MaxY DIV 2)+13,_SCorectorLOGO);
  WriteBetween(1,80,(MaxY DIV 2)-10,$0B,'Thank you for using');
  PosCursor(1,MaxY-4);
  Cursor(On);
  SetBlink(True);
  Halt(0);
END;

BEGIN
  Initialize;
  ExitPGM;
END.